<template>
    <div ref="scrollContainer" class="scroll-container">
      <!-- Pull to refresh -->
      <PullToRefresh ref="pullRefresh" :container="scrollContainer" @refresh="fetchData"></PullToRefresh>
      
      <!-- Page content -->
      <div class="container mx-auto p-5 mb-12">
        <!-- Page title -->
        <PageTitle title="Routines" />

        <Alert v-if="showError" type="error" title="Error" :body="errorText" />

        <!-- List of routines -->
        <GenericWidget v-for="item in list"
          :itemId="item.id" 
          :itemName="item.name" 
          itemType="routine"
          :itemStatus="item.status"
          :itemDescription="item.description"
          @updateStatus= "toggleStatus"
          @editEvent="openEditModal" 
          @deleteEvent="openDeleteModal"
          @clickEvent="navigateToActivities(item)"
        ></GenericWidget>
        
        <!-- Loading -->
        <div v-if="loading">
          <div class="skeleton h-32 w-full flex flex-col justify-center">
            <button class="">
              <span class="loading loading-spinner"></span>
              Fetching Routines...
            </button>
          </div>
        </div>

      </div>
      
      <!-- Modal -->
      <Modal id="routine" :modalData="modalData" @onSubmit="handleSubmit" @closeModal="closeModal" />

      <!-- Add Create Routine button -->
      <FloatingActionButton @click="openCreateModal" />
    </div>
  </template>
  
<script>
  import GenericWidget from '@/components/GenericWidget.vue';
  import PullToRefresh from '@/components/PullToRefresh.vue';
  import PageTitle from '@/components/PageTitle.vue';
  import FloatingActionButton from '@/components/FloatingActionButton.vue';
  import Modal from '@/components/Modal.vue';
  import Alert from '@/components/Alert.vue';

  import ROOMS from '@/assets/rooms.json';
  import ICONS from '@/assets/icons.json';
  
  export default {
    components: {
      GenericWidget,
      PullToRefresh,
      PageTitle,
      FloatingActionButton,
      Modal,
      Alert
    },
    data() {
      return {
        list: [],
        scrollContainer: {},
        modalData: {},
        showError: false,
        loading: false
      };
    },
    mounted() {
        // prepare the pull-to-refresh
        this.scrollContainer = this.$refs.scrollContainer
        this.$refs.pullRefresh.init()
        
        // fetch the data for the first time
        this.fetchData()
    },
    methods: {
      fetchData() {
        // Fetching the list of routines
        var self = this;
        self.loading = true;
        self.$axios.get('/routines', {})
        .then(function (response) {
          // handle success
          self.showError = false
          self.list = response.data;
        })
        .catch(function (error) {
          // handle error
          self.showError = true;
          self.errorText = error.response.data.message;
        })
        .finally(function () {
          // always executed
          self.loading = false;
        });

        setTimeout(() => {
          this.$refs.pullRefresh.refreshSuccess()
        }, 1000)

        this.closeModal();
      },
      create(item) {
        if (this.$refs.pullRefresh.isPulling || this.$refs.pullRefresh.isRefreshing) {
            return
        }
        this.$refs.pullRefresh.stopPull()
 
        var self = this;
        self.$axios.post('/routines', {
          name: item.routineName,
          status: 'active',
          description: item.routineDescription
        })
        .then(function (response) {
          // handle success
          self.showError = false;
          //self.list.push(response.data);
          self.fetchData()
          self.$toast.success("Routine created successfully!");
        })
        .catch(function (error) {
          // handle error
          console.log(error);
          self.showError = true;
          self.$toast.error(error.response.data.message);
        });

        setTimeout(() => {
            this.$refs.pullRefresh.refreshSuccess()
        }, 1000)

        this.closeModal();

      },
      edit(item) {
          if (this.$refs.pullRefresh.isPulling || this.$refs.pullRefresh.isRefreshing) {
              return
          }
          this.$refs.pullRefresh.stopPull()
          
          console.log(item);
          // TODO: PUT /routines
          var self = this;
          self.$axios.put('/routines', {
              id: item.routineId,
              name: item.routineName,
              status: 'inactive',
              description: item.routineDescription
          })
          .then(async (response) => {
            // handle success
            this.fetchData();
            self.$toast.success("Routine edited successfully!");
          })
          .catch(function (error) {
            // handle error
            console.log(error);
            self.showError = true;
            self.$toast.error(error.response.data.message);
          });

          setTimeout(() => {
            this.$refs.pullRefresh.refreshSuccess()
          }, 1000)

          this.closeModal();
      },
      remove(item) {
          if (this.$refs.pullRefresh.isPulling || this.$refs.pullRefresh.isRefreshing) {
              return
          }
          this.$refs.pullRefresh.stopPull()

          var self = this;
          self.$axios.delete("/routines", {
            data: {
                id: item.routineId
            }
          })
          .then(async (response) => {
            // handle success
            self.$toast.success("Routine deleted successfully!");
            // Remove the deleted routine from the local list
            self.list = self.list.filter(r => r.id !== item.routineId);

            // Check if the list is empty and update the error message
            if (self.list.length === 0) {
                self.showError = true;
                self.errorText = "No routines found.";
            }
          })
          .catch(async (error) => {
            // handle error
            if (self.list.length === 0) {
                self.showError = true;
                self.errorText = "No routines found.";
            } else {
                self.showError = true;
                self.$toast.error(error.response.data.message);
            }
          });

          setTimeout(() => {
            this.$refs.pullRefresh.refreshSuccess()
          }, 1000)

          this.closeModal();
      },
      toggleStatus(newData) {
          console.log(newData)
          var self = this;
          self.$axios.put('/routines', newData)
          .then(async function (response) {
            // handle success
            self.$toast.success("Status update successfully!");
          }).catch(function (error) {
              self.$toast.error(error.response.data.message);
          });
      },
      navigateToActivities(routine) {
        // Use the router to navigate to Activities.vue with routineId as a route parameter
        this.$router.push({
          name: "Activities",
          params: { 
            routineId: routine.id
          },
        });
      },

      /**
      * Functions that create the "fields" and "buttons" props for the modal component, then open the modal.
      */
      openCreateModal() {
        this.modalData = {
          id: "createRoutine",
          title: "Create Routine",
          text: "Fill all the fields in this form to create a routine.",
          fields: [
              {
                  label: 'Name',
                  type: 'input',
                  placeholder: 'Routine Name (e.g. Vacation, Daily, etc.)',
                  value: '',
                  required: true,
                  id: 'routineName',
              },
              {
                  label: 'Description',
                  type: 'textarea',
                  placeholder: 'Routine Description (e.g. This is the routine for the daily activities.)',
                  value: '',
                  required: true,
                  id: 'routineDescription',
              }  
          ],
          buttons: [
              { text: "Close", cssClass: "", onClick: "closeModal", type: "button", enabled: true },
              { text: "Confirm", cssClass: "btn-primary", type: "submit", enabled: true, onClick: "" }
          ],
          onSubmit: "create"
        }
        // opens the (creation) form
        routine.showModal()
      },
      openDeleteModal(item) {
        // forms for item deletion
        this.modalData = {
            id: "deleteRoutine",
            title: "Delete Routine",
            text: "Are you sure you want to delete this routine? By deleting this routine, all the associated activities will be deleted too",
            fields: [
                {
                    label: '',
                    type: 'hidden',
                    value: item.itemId,
                    required: true,
                    id: 'routineId',
                }
            ],
            buttons: [
                { text: "Close", cssClass: "", onClick: "closeModal", type: "button", enabled: true },
                { text: "Confirm", cssClass: "btn-primary", type: "submit", enabled: true, onClick: "" }
            ],
            onSubmit: "remove"
        };
        
        routine.showModal();
      },

      openEditModal(item) {
        console.log(item.itemId);
        // forms for item deletion
        this.modalData = {
            id: "editRoutine",
            title: "Edit Routine",
            text: "Change the fields you want to edit and click confirm to save the changes.",
            fields: [
                {
                    label: 'Change Name',
                    type: 'input',
                    placeholder: item.itemName,
                    value: item.itemName,
                    required: false,
                    id: 'routineName',
                },
                {
                    label: 'Change Description',
                    type: 'input',
                    placeholder: item.itemDescription,
                    value: item.itemDescription,
                    required: false,
                    id: 'routineDescription',
                },
                {
                    label: '',
                    type: 'hidden',
                    value: item.itemId,
                    required: true,
                    id: 'routineId',
                }
            ],
            buttons: [
                { text: "Close", cssClass: "", onClick: "closeModal", type: "button", enabled: true },
                { text: "Confirm", cssClass: "btn-primary", type: "submit", enabled: true, onClick: "" }
            ],
            onSubmit: "edit"
        };
        routine.showModal();
      },

      /**
       * Generic function that closes all the modals.
       */
      closeModal() {
        routine.close()
      },
      handleSubmit(data){
        this[this.modalData.onSubmit](data)
      }
    }
  }
</script>
  